﻿function atualizaDropdowns(obj) {
    var todos = [$("#ddlTipoSala"), $("#ddlCampus"), $("#ddlPredio"), $("#ddlBloco"), $("#ddlSala")];
    obj = $(obj);
    // Localiza o elemento que foi atualizado
    var atualizado = -1;
    if (obj !== null && typeof (obj) !== "undefined") {
        $.each(todos, function (idx, value) {
            if (obj.attr("id") == value.attr("id"))
                atualizado = idx;
        });
    }

    // Remove as opções extras (ou seja, não a "todos") dos dropdowns localizados
    // após aquele que foi modificado
    switch (atualizado) {
        case -1:
            removeOpcoesDinamicas("#ddlTipoSala");
        case 0:
            removeOpcoesDinamicas("#ddlCampus");
        case 1:
            removeOpcoesDinamicas("#ddlPredio");
        case 2:
            removeOpcoesDinamicas("#ddlBloco");
        case 3:
            removeOpcoesDinamicas("#ddlSala");
    }

    // Filtra a lista de salas, de acordo com o tipo de sala escolhido
    var tipo = trocaStringVaziaPorNull($("#ddlTipoSala").val());
    var salas_filtrado = lista_salas.filter(function (obj, idx) {
        return ((tipo == "*") || (obj.tipoSala && obj.tipoSala.codTipoSala == tipo));
    });

    // Filtra os dropdowns seguintes
    switch (atualizado) {
        case -1: // Atualiza o dropdown de tipos de salas
            // Atualiza os tipos de sala
            $.each(tipos_sala, function (idx, value) {
                $("<option />").val(value.codTipoSala).text(value.nome).appendTo("#ddlTipoSala");
            });

        case 0: // Atualiza o dropdown de campus
            var campus = [];
            // Cria um novo array com as opções únicas
            $.each(salas_filtrado, function (idx, value) {
                var existe = false;
                $.each(campus, function (idxi, valuei) {
                    existe = existe || (valuei.codCampus == value.codCampus && valuei.campus == value.campus);
                });
                if (!existe)
                    campus.push({ codCampus: value.codCampus, campus: value.campus });
            });

            // Adiciona essas opções no dropdown
            $.each(campus, function (idx, value) {
                $("<option />").val(value.codCampus).text(value.campus).appendTo($("#ddlCampus"));
            });
            break;

        case 1: // Atualiza o dropdown de prédios
            var campus_selecionado = trocaStringVaziaPorNull($("#ddlCampus").val());
            if (campus_selecionado !== "*") {
                var predio = [];
                // Cria um novo array com as opções únicas e filtrado
                $.each(salas_filtrado, function (idx, value) {
                    if (value.codCampus == campus_selecionado) {
                        var existe = false;
                        $.each(predio, function (idxi, valuei) {
                            existe = existe || (valuei.codPredio == value.codPredio && valuei.predio == value.predio);
                        });
                        if (!existe)
                            predio.push({ codPredio: value.codPredio, predio: value.predio });
                    }
                });

                // Adiciona essas opções no dropdown
                $.each(predio, function (idx, value) {
                    $("<option />").val(value.codPredio).text(value.predio).appendTo($("#ddlPredio"));
                });
            }
            break;

        case 2: // Atualiza o dropdown de blocos
            var campus_selecionado = trocaStringVaziaPorNull($("#ddlCampus").val());
            var predio_selecionado = trocaStringVaziaPorNull($("#ddlPredio").val());
            if (predio_selecionado !== "*") {
                var bloco = [];
                // Cria um novo array com as opções únicas e filtrado
                $.each(salas_filtrado, function (idx, value) {
                    if (value.codCampus == campus_selecionado && value.codPredio == predio_selecionado) {
                        var existe = false;
                        $.each(bloco, function (idxi, valuei) {
                            existe = existe || (valuei.codBloco == value.codBloco && valuei.bloco == value.bloco);
                        })
                        if (!existe)
                            bloco.push({ codBloco: value.codBloco, bloco: value.bloco });
                    }
                });

                // Adiciona essas opções no dropdown
                $.each(bloco, function (idx, value) {
                    $("<option />").val(value.codBloco).text(value.bloco).appendTo($("#ddlBloco"));
                });
            }
            break;

        case 3: // Atualiza o dropdown de salas
            var campus_selecionado = trocaStringVaziaPorNull($("#ddlCampus").val());
            var predio_selecionado = trocaStringVaziaPorNull($("#ddlPredio").val());
            var bloco_selecionado = trocaStringVaziaPorNull($("#ddlBloco").val());
            if (bloco_selecionado !== "*") {
                var sala = [];
                // Cria um novo array com as opções únicas e filtrado
                $.each(salas_filtrado, function (idx, value) {
                    if (value.codCampus == campus_selecionado && value.codPredio == predio_selecionado && value.codBloco == bloco_selecionado) {
                        var existe = false;
                        $.each(sala, function (idxi, valuei) {
                            existe = existe || (valuei.codSala == value.codSala && valuei.sala == value.sala);
                        })
                        if (!existe)
                            sala.push({ codSala: value.codSala, sala: value.sala });
                    }
                });

                // Adiciona essas opções no dropdown
                $.each(sala, function (idx, value) {
                    $("<option />").val(value.codSala).text(value.sala).appendTo($("#ddlSala"));
                });
            }
            break;
    }
}

function inicializaCalendario() {
    internalInicializaCalendario({
        events: function (start, end, timezone, callback) {
            $.ajax({
                url: URLReservasInstalacoes,
                dataType: "json",
                data: {
                    start: start.format("YYYY-MM-DD"),
                    end: end.format("YYYY-MM-DD"),
                    codcampus: getOptionValueOrEmpty("#ddlCampus"),
                    codpredio: getOptionValueOrEmpty("#ddlPredio"),
                    codbloco: getOptionValueOrEmpty("#ddlBloco"),
                    codsala: getOptionValueOrEmpty("#ddlSala"),
                    codtiposala: getOptionValueOrEmpty("#ddlTipoSala")
                },
                success: function (doc) {
                    callback(doc);
                },
                error: function (doc) {
                    $("#carregando").hide();
                    alert("Ocorreu um erro ao carregar os registros. Tente novamente.");
                }
            });
        },
        resources: function (callback, start, end, timezone) {
            $.ajax({
                url: URLListaSalas,
                dataType: "json",
                data: {
                    start: start.format("YYYY-MM-DD"),
                    end: end.format("YYYY-MM-DD"),
                    codcampus: getOptionValueOrEmpty("#ddlCampus"),
                    codpredio: getOptionValueOrEmpty("#ddlPredio"),
                    codbloco: getOptionValueOrEmpty("#ddlBloco"),
                    codsala: getOptionValueOrEmpty("#ddlSala"),
                    codtiposala: getOptionValueOrEmpty("#ddlTipoSala")
                },
                success: function (doc) {
                    callback(doc);
                },
                error: function (doc) {
                    $("#carregando").hide();
                    alert("Ocorreu um erro ao carregar os registros. Tente novamente.");
                }
            });
        },
        eventMouseover: function (calEvent, jsEvent, view) {
            $(this).smallipop({}, montaVisaoDetalhes(calEvent));
        },
        resourceOrder: "sala",
        resourceText: function (resource) {
            return resource.sala || resource.id;
        },
        resourceLabelText: 'Instalações'
    });
}

$(document).ready(function () {
    // Preenche as salas nos dropdowns
    atualizaDropdowns();

    // Adiciona eventos nos dropdowns de filtro para que, quando um for alterado, os dropdowns que
    // dependem dele sejam atualizados
    $("#ddlTipoSala").change(function () { atualizaDropdowns(this); });
    $("#ddlCampus").change(function () { atualizaDropdowns(this); });
    $("#ddlPredio").change(function () { atualizaDropdowns(this); });
    $("#ddlBloco").change(function () { atualizaDropdowns(this); });
    $("#ddlSala").change(function () { atualizaDropdowns(this); });

    // Preenche os valores iniciais nos dropdowns de filtro
    preencheCamposQueryString();

    // Inicializar o calendário
    inicializaCalendario();

    // Adiciona eventos para que, ao modificar um dropdown, o calendário seja atualizado
    $("#ddlTipoSala").change(atualizaCalendario);
    $("#ddlCampus").change(atualizaCalendario);
    $("#ddlPredio").change(atualizaCalendario);
    $("#ddlBloco").change(atualizaCalendario);
    $("#ddlSala").change(atualizaCalendario);

    // Ao modificar o turno, regera o calendário (necessário para que o intervalo de horários apresentado seja limitado)
    $("#ddlTurno").change(inicializaCalendario);
});

$(window).resize(function () {
    // Redimensiona a altura do calendário se o tamanho da tela mudar.
    // O redimensionamento da largura é feito via CSS.
    $('#calendar').fullCalendar('option', 'height', window.innerHeight - 150);
});
