﻿function atualizaDropdowns(obj) {
    var todos = [$("#ddlTipoRecurso"), $("#ddlRecurso")];
    obj = $(obj);
    // Localiza o elemento que foi atualizado
    var atualizado = -1;
    if (obj !== null && typeof (obj) !== "undefined") {
        $.each(todos, function (idx, value) {
            if (obj.attr("id") == value.attr("id"))
                atualizado = idx;
        });
    }

    // Remove as opções extras (ou seja, não a "todos") dos dropdowns localizados
    // após aquele que foi modificado
    switch (atualizado) {
        case -1:
            removeOpcoesDinamicas("#ddlTipoRecurso");
        case 0:
            removeOpcoesDinamicas("#ddlRecurso");
    }

    // Filtra a lista de salas, de acordo com o tipo de sala escolhido
    var tipo = $("#ddlTipoRecurso").val();
    var recursos_filtrado = lista_recursos.filter(function (obj, idx) {
        return ((tipo == "*") || (obj.tipoRecurso && obj.tipoRecurso.codTipoRecurso == tipo));
    });

    // Filtra os dropdowns seguintes
    switch (atualizado) {
        case -1: // Atualiza o dropdown de tipos de recursos
            // Atualiza os tipos de recursos
            $.each(tipos_recurso, function (idx, value) {
                $("<option />").val(value.codTipoRecurso).text(value.nome).appendTo("#ddlTipoRecurso");
            });

        case 0: // Atualiza o dropdown de recursos
            // Adiciona essas opções no dropdown
            $.each(recursos_filtrado, function (idx, value) {
                $("<option />").val(value.idBem).text(value.nome).appendTo($("#ddlRecurso"));
            });
            break;
    }
}

function inicializaCalendario() {
    internalInicializaCalendario({
        events: function (start, end, timezone, callback) {
            $.ajax({
                url: URLReservasRecursos,
                dataType: "json",
                data: {
                    start: start.format("YYYY-MM-DD"),
                    end: end.format("YYYY-MM-DD"),
                    codtiporecurso: getOptionValueOrEmpty("#ddlTipoRecurso"),
                    codrecurso: getOptionValueOrEmpty("#ddlRecurso")
                },
                success: function (doc) {
                    callback(doc);
                },
                error: function (doc) {
                    $("#carregando").hide();
                    alert("Ocorreu um erro ao carregar os registros. Tente novamente.");
                }
            });
        },
        resources: function (callback, start, end, timezone) {
            $.ajax({
                url: URLListaRecursos,
                dataType: "json",
                data: {
                    start: start.format("YYYY-MM-DD"),
                    end: end.format("YYYY-MM-DD"),
                    codtiporecurso: getOptionValueOrEmpty("#ddlTipoRecurso"),
                    codrecurso: getOptionValueOrEmpty("#ddlRecurso")
                },
                success: function (doc) {
                    callback(doc);
                },
                error: function (doc) {
                    $("#carregando").hide();
                    alert("Ocorreu um erro ao carregar os registros. Tente novamente.");
                }
            });
        },
        eventMouseover: function (calEvent, jsEvent, view) {
            $(this).smallipop({}, montaVisaoDetalhes(calEvent));
        },
        resourceOrder: "nome",
        resourceText: function (resource) {
            return resource.nome || resource.tipoRecurso;
        },
        resourceLabelText: "Recursos"
    });
}

$(document).ready(function () {
    // Preenche os dropdowns
    atualizaDropdowns();

    // Adiciona eventos nos dropdowns de filtro para que, quando um for alterado, os dropdowns que
    // dependem dele sejam atualizados
    $("#ddlTipoRecurso").change(function () { atualizaDropdowns(this); });
    $("#ddlRecurso").change(function () { atualizaDropdowns(this); });

    // Preenche os valores iniciais nos dropdowns de filtro
    preencheCamposQueryString();

    // Inicializar o calendário
    inicializaCalendario();

    // Adiciona eventos para que, ao modificar um dropdown, o calendário seja atualizado
    $("#ddlTipoRecurso").change(atualizaCalendario);
    $("#ddlRecurso").change(atualizaCalendario);

    // Ao modificar o turno, regera o calendário (necessário para que o intervalo de horários apresentado seja limitado)
    $("#ddlTurno").change(inicializaCalendario);
});

$(window).resize(function () {
    // Redimensiona a altura do calendário se o tamanho da tela mudar.
    // O redimensionamento da largura é feito via CSS.
    $('#calendar').fullCalendar('option', 'height', window.innerHeight - 150);
});